import java.util.Vector;

public class PinBallThread extends Thread
{
  private PinBall     theBall;
  private PinBallGame theWorld;

  public PinBallThread( PinBall aBall, PinBallGame aWorld )
  {
    theBall  = aBall;
    theWorld = aWorld;
  }

  public void run()
  {
    while ( theBall.y() < theWorld.getHeight() )
    {
      theBall.move ();

      Vector targets = theWorld.targets();
      for ( int j = 0; j < targets.size(); j++ )
      {
        PinBallTarget target = (PinBallTarget) targets.elementAt( j );
        if ( target.intersects( theBall ) )
          target.hitBy( theBall );
      }
      
      theWorld.repaint();

      try {
        sleep( 10 );
      }
      catch ( InterruptedException e ) {
        System.exit( 0 );
      }
    }
  }
}
