import java.awt.*;
import java.awt.event.*;

public class MouseListenerFrame extends Frame
{
  public static final int FrameWidth  = 400;
  public static final int FrameHeight = 400;

  private MouseKeeper listener;

  public MouseListenerFrame()
  {
    setTitle( "MouseListener Demo" );
    setSize ( FrameWidth, FrameHeight );

    listener = new MouseKeeper();
    addMouseListener( listener );
  }

  public void paint( Graphics g )
  {
    g.drawString( "Coordinates = (" + listener.lastX + ", " +
                                      listener.lastY + ")",
                  10, 50 );
  }

  private class MouseKeeper implements MouseListener
  {
    private int lastX;
    private int lastY;

    public MouseKeeper()
    {
      lastX = 0;
      lastY = 0;
    }

    public void mousePressed( MouseEvent e )
    {
      lastX = e.getX();
      lastY = e.getY();
      repaint();
    }

    public void mouseReleased( MouseEvent e ) {}
    public void mouseClicked ( MouseEvent e ) {}
    public void mouseEntered ( MouseEvent e ) {}
    public void mouseExited  ( MouseEvent e ) {}
  }
}
